﻿var authentificated = false;
var connected_user;

var error_display = "We're sorry, an error occured :( ";

var displayed_messages_limit = 5;

// The current discussion mode
var discussionMode;

// The different discussion modes
var discussions = new Array();
discussions['messages'] = "https://www.yammer.com/api/v1/messages.json";
discussions['feed'] = "https://www.yammer.com/api/v1/messages/my_feed.json";
discussions['algo'] = "https://www.yammer.com/api/v1/messages/algo.json";
discussions['following'] = "https://www.yammer.com/api/v1/messages/following.json";

// The displayed description
var discussions_descr = new Array();
discussions_descr['messages'] = "All my messages";
discussions_descr['feed'] = "My feed";
discussions_descr['algo'] = "Top conversations";
discussions_descr['following'] = "Following conversations";

var intro_phrase = "You are seeing : ";

// User connected
connection_callback = function (resp) {
    if (resp.authResponse) {
        connected_user = resp['user'];
        console.log(connected_user);
        $('#auth_part').hide();
        $('#loading_part').hide();
        $('#home_part > h2').append(connected_user['full_name']);
        $('#home_part').fadeIn('slow');

        getMessages(discussions[discussionMode]);

    } else {
        $('#loading_part').hide();
        $('#error_part > h3').html(error_display + "Couldn't connect to your yammer account.");
        $('#error_part').fadeIn('slow');
    }
};

// Retrieve the messages
getMessages = function (url) {
    $('#loading_part').show();
    yam.request({
        url: url,
        method: "GET",
        data: {},
        success: messagesReceived,
        error: function (err) {
            $('#error_part > h3').html(error_display + "Couldn't retrieve messages.");
            console.log(err);
            $('#error_part').fadeIn('slow');
            $('#loading_part').hide();
        }
    });
};

// Messages received
messagesReceived = function (data) {
    $('#loading_part').hide();
    $('#home_part h3').html(intro_phrase + discussions_descr[discussionMode]);

    console.log(data);
    for (var i = 0; i < data['messages'].length && i < displayed_messages_limit; i++) {

        var sender = getUserFromId(data['references'], data['messages'][i]['sender_id']);

        // Date
        var date = new Date(data['messages'][i]['created_at']);
        var timeDiff = Math.abs(new Date().getTime() - date.getTime());
        var unity = 'days';
        var nb_diff = 1;

        if (timeDiff < 1000 * 60) {
            unity = 'minutes';
            nb_diff = Math.ceil(timeDiff / (1000 * 60));
        } else if (Math.ceil(timeDiff / (1000 * 60)) < 60 * 24) {
            unity = 'hours';
            nb_diff = Math.ceil(timeDiff / (1000 * 3600));
        } else {
            nb_diff = Math.ceil(timeDiff / (1000 * 3600 * 24));
        }

        //$('#yammer4sharepoint #home_part #messages').append('<div class="message"><div class="from"><img src="' + sender['mugshot_url'] + '"/><span>From : ' + sender['full_name'] + '</span></div>' +
        //  data['messages'][i]['body']['rich'] + '<div class="time">' + nb_diff + ' ' + unity + ' ago</div></div>');

        $('#yammer4sharepoint #home_part #messages').append('<tr><td><li><div><div class="message-body"><div class="message-image"><img width="48px" height="48px" src="' +
           sender['mugshot_url'] + '"/></div><div class="message-container"> <div><span class="message_username">' + sender['full_name'] + '</span></div> <div></div ><div class="message-content">' + data['messages'][i]['body']['rich'] +
           '</div><div class="time">' + nb_diff + ' ' + unity + ' ago</div></div></div></div></li></td></tr>');
    }
};

// Get the user from its ID
getUserFromId = function (references, id) {
    for (var j = 0; j < references.length; j++) {
        if (references[j]['type'] != 'user')
            continue;

        if (references[j]['id'] == id)
            return references[j];
    }
    return 'undefined';
};



// Document ready
//
$(document).ready(function () {
    yam.connect.loginButton('#yammer-login', connection_callback);
   
    // Get the user discussion mode
    var disc = $('#yammer4sharepoint > data > discussion > span:first-child');
    if (disc.length > 0)
    {
        discussionMode = disc.html();
    }
    else
    {
        // default value
        discussionMode = 'messages';
    }
});


