﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using YammerWebPart1.VisualWebPart1.CustomTools;
using Microsoft.SharePoint.WebPartPages;
using System.Collections.Generic;

namespace YammerWebPart1.VisualWebPart1
{
   

    [ToolboxItemAttribute(false)]
    public class VisualWebPart1 : Microsoft.SharePoint.WebPartPages.WebPart
    {
        public List<Discussion> Discussions { get; set; }
        public Discussion ChosenDiscussion { get; set; }

        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/15/YammerWebPart1/VisualWebPart1/VisualWebPart1UserControl.ascx";

        public VisualWebPart1UserControl UserControl { get; set; }
        public OptionsToolpart OptionFieldsPartControl { get; set; }

        public VisualWebPart1()
        {
            this.OptionFieldsPartControl = new OptionsToolpart();

            this.Discussions = new List<Discussion>();

            this.Discussions.Add(new Discussion() { Name = "messages", Displayed = "All my messages" });
            this.Discussions.Add(new Discussion() { Name = "feed", Displayed = "My feed" });
            this.Discussions.Add(new Discussion() { Name = "algo", Displayed = "Top conversations" });
            this.Discussions.Add(new Discussion() { Name = "following", Displayed = "Following conversations" });

            if (this.ChosenDiscussion == null)
                this.ChosenDiscussion = this.Discussions[0];
        }

        protected override void CreateChildControls()
        {
            Control control = Page.LoadControl(_ascxPath);
            Controls.Add(control);

            UserControl = (VisualWebPart1UserControl)control;
            UserControl.WP = this;
        }

        public override ToolPart[] GetToolParts()
        {
            ToolPart[] toolparts = new ToolPart[3];
            WebPartToolPart wptp = new WebPartToolPart();
            CustomPropertyToolPart custom = new CustomPropertyToolPart();
            toolparts[0] = custom;
            toolparts[1] = wptp;

            this.OptionFieldsPartControl.ID = "customOptions";
            this.OptionFieldsPartControl.Title = "Choose a discussion";
            this.OptionFieldsPartControl.AllowMinimize = true;
            this.Wrap = true;

            toolparts[2] = this.OptionFieldsPartControl;

            return toolparts;
        }

        public class Discussion
        {
            public string Name { get; set; }
            public string Displayed { get; set; }

            public override string ToString()
            {
                return Name;
            }

            public override bool Equals(object obj)
            {
                return Name == ((Discussion)obj).Name;
            }
        }
    }
}
